package meta_programming;

import java.lang.reflect.Array;
import java.lang.reflect.Field;

import meta_programming.Sample13.Foo;

public class Sample14 {
	public static void main(String[] args) throws Exception {
		String toString = ToStringBuilder.toString(new Foo());
		System.out.println(toString);
	}

	public static class ToStringBuilder {
		public static String toString(Object o) {
			StringBuilder ret = new StringBuilder();

			ret.append(o.getClass().getName());
			ret.append("[");

			Field[] declaredFields = o.getClass()
					.getDeclaredFields();

			for (Field field : declaredFields) {
				field.setAccessible(true);
				try {
					ret.append(field.getName() + " = "
							+ toString(field, o));
					ret.append(", ");
				} catch (IllegalArgumentException ignore) {
				} catch (IllegalAccessException ignore) {
				}
			}

			if (0 < declaredFields.length) {
				ret.setLength(ret.length() - 2);
			}
			ret.append("]");

			return ret.toString();
		}

		private static Object toString(Field field, Object o)
				throws IllegalAccessException {
			Object fieldValue = field.get(o);
			if (fieldValue == null) {
				return null;
			}
			if (field.getType().isArray() == false) {
				return fieldValue;
			}

			StringBuilder ret = new StringBuilder();
			ret.append("[");
			int length = Array.getLength(fieldValue);
			for (int i = 0; i < length; i++) {
				ret.append(Array.get(fieldValue, i));
				ret.append(", ");
			}
			if (0 < length) {
				ret.setLength(ret.length() - 2);
			}
			ret.append("]");
			return ret.toString();
		}
	}

}
