package meta_programming;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.List;

public class Sample15 {

	public static void main(String[] args) throws Exception {

		Method method = Number.class.getMethod("doubleValue");
		int modifiers = method.getModifiers();
		println(method);
		println("isAbstract  : "
				+ Modifier.isAbstract(modifiers));
		println("isStatic    : " + Modifier.isStatic(modifiers));
		println("isPublic    : " + Modifier.isPublic(modifiers));
		System.out.println();

		method = String.class.getMethod("valueOf", int.class);
		modifiers = method.getModifiers();
		println(method);
		println("isAbstract  : "
				+ Modifier.isAbstract(modifiers));
		println("isStatic    : " + Modifier.isStatic(modifiers));
		println("isPublic    : " + Modifier.isPublic(modifiers));
		System.out.println();

		Class<?> clazz = String.class;
		println(clazz);
		println("isInterface : "
				+ Modifier.isInterface(clazz.getModifiers()));
		System.out.println();

		clazz = List.class;
		println(clazz);
		println("isInterface : "
				+ Modifier.isInterface(clazz.getModifiers()));
		System.out.println();
	}

	private static void println(Object o) {
		System.out.println(o);
	}
}
